# coding: utf-8

"""
    Registry API

    Registry API enabling advanced search on PDS data and metadata. The API provides end-points to search for bundles, collections and any PDS products with advanced search queries. It also enables to browse the archive hierarchically downward (e.g. collection/s products) or upward (e.g. bundles containing a product). The detailed syntax for querying the end-point is given in the reference documentation.   # noqa: E501

    The version of the OpenAPI document: 1.1
    Contact: pds-operator@jpl.nasa.gov
    Generated by: https://openapi-generator.tech
"""

from pds.api_client.paths.bundles.get import BundleList
from pds.api_client.paths.bundles_identifier.get import BundlesLidvid
from pds.api_client.paths.bundles_identifier_all.get import BundlesLidvidAll
from pds.api_client.paths.bundles_identifier_collections.get import BundlesLidvidCollections
from pds.api_client.paths.bundles_identifier_collections_all.get import BundlesLidvidCollectionsAll
from pds.api_client.paths.bundles_identifier_collections_latest.get import BundlesLidvidCollectionsLatest
from pds.api_client.paths.bundles_identifier_latest.get import BundlesLidvidLatest
from pds.api_client.paths.bundles_identifier_products.get import BundlesLidvidProducts
from pds.api_client.paths.collections.get import CollectionList
from pds.api_client.paths.collections_identifier.get import CollectionsLidvid
from pds.api_client.paths.collections_identifier_all.get import CollectionsLidvidAll
from pds.api_client.paths.collections_identifier_bundles.get import CollectionsLidvidBundles
from pds.api_client.paths.collections_identifier_latest.get import CollectionsLidvidLatest
from pds.api_client.paths.collections_identifier_products.get import CollectionsLidvidProducts
from pds.api_client.paths.collections_identifier_products_all.get import CollectionsLidvidProductsAll
from pds.api_client.paths.collections_identifier_products_latest.get import CollectionsLidvidProductsLatest
from pds.api_client.paths.products_identifier_bundles_all.get import ProductsLidividBundlesAll
from pds.api_client.paths.products_identifier_bundles.get import ProductsLidvidBundles
from pds.api_client.paths.products_identifier_bundles_latest.get import ProductsLidvidBundlesLatest
from pds.api_client.paths.products_identifier_collections.get import ProductsLidvidCollections
from pds.api_client.paths.products_identifier_collections_all.get import ProductsLidvidCollectionsAll
from pds.api_client.paths.products_identifier_collections_latest.get import ProductsLidvidCollectionsLatest


class DeprecatedApi(
    BundleList,
    BundlesLidvid,
    BundlesLidvidAll,
    BundlesLidvidCollections,
    BundlesLidvidCollectionsAll,
    BundlesLidvidCollectionsLatest,
    BundlesLidvidLatest,
    BundlesLidvidProducts,
    CollectionList,
    CollectionsLidvid,
    CollectionsLidvidAll,
    CollectionsLidvidBundles,
    CollectionsLidvidLatest,
    CollectionsLidvidProducts,
    CollectionsLidvidProductsAll,
    CollectionsLidvidProductsLatest,
    ProductsLidividBundlesAll,
    ProductsLidvidBundles,
    ProductsLidvidBundlesLatest,
    ProductsLidvidCollections,
    ProductsLidvidCollectionsAll,
    ProductsLidvidCollectionsLatest,
):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    pass
