# coding: utf-8

"""
    PDS Registry Search API

    Registry API enabling advanced search on PDS data and metadata. The API provides end-points to search for bundles, collections and any PDS products with advanced search queries. It also enables to browse the archive hierarchically downward (e.g. collection/s products) or upward (e.g. bundles containing a product).   # noqa: E501

    The version of the OpenAPI document: 1.1.1
    Contact: pds-operator@jpl.nasa.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr
from pds.api_client.models.pds4_metadata import Pds4Metadata

class Pds4Product(BaseModel):
    """
    PDS product description as structured by the PDS4 information model (https://pds.nasa.gov/datastandards/documents/im/)
    """
    id: StrictStr = Field(..., description="LIDVID")
    metadata: Optional[Pds4Metadata] = None
    pds4: Optional[Dict[str, Any]] = Field(None, description="PDS4 JSON")
    __properties = ["id", "metadata", "pds4"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Pds4Product:
        """Create an instance of Pds4Product from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Pds4Product:
        """Create an instance of Pds4Product from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Pds4Product.parse_obj(obj)

        _obj = Pds4Product.parse_obj({
            "id": obj.get("id"),
            "metadata": Pds4Metadata.from_dict(obj.get("metadata")) if obj.get("metadata") is not None else None,
            "pds4": obj.get("pds4")
        })
        return _obj

