# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from pds.api_client.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    CLASSES = "/classes"
    CLASSES_CLASS = "/classes/{class}"
    CLASSES_CLASS_IDENTIFIER_MEMBERS = "/classes/{class}/{identifier}/members"
    CLASSES_CLASS_IDENTIFIER_MEMBERS_VERSIONS = "/classes/{class}/{identifier}/members/{versions}"
    CLASSES_CLASS_IDENTIFIER_MEMBERS_MEMBERS = "/classes/{class}/{identifier}/members/members"
    CLASSES_CLASS_IDENTIFIER_MEMBERS_MEMBERS_VERSIONS = "/classes/{class}/{identifier}/members/members/{versions}"
    CLASSES_CLASS_IDENTIFIER_MEMBEROF = "/classes/{class}/{identifier}/member-of"
    CLASSES_CLASS_IDENTIFIER_MEMBEROF_VERSIONS = "/classes/{class}/{identifier}/member-of/{versions}"
    CLASSES_CLASS_IDENTIFIER_MEMBEROF_MEMBEROF = "/classes/{class}/{identifier}/member-of/member-of"
    CLASSES_CLASS_IDENTIFIER_MEMBEROF_MEMBEROF_VERSIONS = "/classes/{class}/{identifier}/member-of/member-of/{versions}"
    PRODUCTS = "/products"
    PRODUCTS_IDENTIFIER = "/products/{identifier}"
    PRODUCTS_IDENTIFIER_LATEST = "/products/{identifier}/latest"
    PRODUCTS_IDENTIFIER_ALL = "/products/{identifier}/all"
    PRODUCTS_IDENTIFIER_MEMBERS = "/products/{identifier}/members"
    PRODUCTS_IDENTIFIER_MEMBERS_VERSIONS = "/products/{identifier}/members/{versions}"
    PRODUCTS_IDENTIFIER_MEMBERS_MEMBERS = "/products/{identifier}/members/members"
    PRODUCTS_IDENTIFIER_MEMBERS_MEMBERS_VERSIONS = "/products/{identifier}/members/members/{versions}"
    PRODUCTS_IDENTIFIER_MEMBEROF = "/products/{identifier}/member-of"
    PRODUCTS_IDENTIFIER_MEMBEROF_VERSIONS = "/products/{identifier}/member-of/{versions}"
    PRODUCTS_IDENTIFIER_MEMBEROF_MEMBEROF = "/products/{identifier}/member-of/member-of"
    PRODUCTS_IDENTIFIER_MEMBEROF_MEMBEROF_VERSIONS = "/products/{identifier}/member-of/member-of/{versions}"
    BUNDLES = "/bundles"
    BUNDLES_IDENTIFIER = "/bundles/{identifier}"
    BUNDLES_IDENTIFIER_ALL = "/bundles/{identifier}/all"
    BUNDLES_IDENTIFIER_LATEST = "/bundles/{identifier}/latest"
    BUNDLES_IDENTIFIER_COLLECTIONS = "/bundles/{identifier}/collections"
    BUNDLES_IDENTIFIER_COLLECTIONS_ALL = "/bundles/{identifier}/collections/all"
    BUNDLES_IDENTIFIER_COLLECTIONS_LATEST = "/bundles/{identifier}/collections/latest"
    BUNDLES_IDENTIFIER_PRODUCTS = "/bundles/{identifier}/products"
    COLLECTIONS = "/collections"
    COLLECTIONS_IDENTIFIER = "/collections/{identifier}"
    COLLECTIONS_IDENTIFIER_ALL = "/collections/{identifier}/all"
    COLLECTIONS_IDENTIFIER_LATEST = "/collections/{identifier}/latest"
    COLLECTIONS_IDENTIFIER_BUNDLES = "/collections/{identifier}/bundles"
    COLLECTIONS_IDENTIFIER_PRODUCTS = "/collections/{identifier}/products"
    COLLECTIONS_IDENTIFIER_PRODUCTS_ALL = "/collections/{identifier}/products/all"
    COLLECTIONS_IDENTIFIER_PRODUCTS_LATEST = "/collections/{identifier}/products/latest"
    PRODUCTS_IDENTIFIER_BUNDLES = "/products/{identifier}/bundles"
    PRODUCTS_IDENTIFIER_BUNDLES_ALL = "/products/{identifier}/bundles/all"
    PRODUCTS_IDENTIFIER_BUNDLES_LATEST = "/products/{identifier}/bundles/latest"
    PRODUCTS_IDENTIFIER_COLLECTIONS = "/products/{identifier}/collections"
    PRODUCTS_IDENTIFIER_COLLECTIONS_ALL = "/products/{identifier}/collections/all"
    PRODUCTS_IDENTIFIER_COLLECTIONS_LATEST = "/products/{identifier}/collections/latest"
